# FFTW.jl

[![CI](https://github.com/JuliaMath/FFTW.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/JuliaMath/FFTW.jl/actions/workflows/CI.yml)
[![Coveralls](https://coveralls.io/repos/github/JuliaMath/FFTW.jl/badge.svg?branch=master)](https://coveralls.io/github/JuliaMath/FFTW.jl?branch=master)

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaMath.github.io/FFTW.jl/stable)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaMath.github.io/FFTW.jl/dev)

This package provides Julia bindings to the [FFTW](http://www.fftw.org/) library for
fast Fourier transforms (FFTs), as well as functionality useful for signal processing.
These functions were formerly a part of Base Julia.

## Usage and documentation

```julia
]add FFTW
using FFTW
fft([0; 1; 2; 1])
```
returns
```
4-element Array{Complex{Float64},1}:
  4.0 + 0.0im
 -2.0 + 0.0im
  0.0 + 0.0im
 -2.0 + 0.0im
```

The documentation of generic FFT functionality can be found in the [AbstractFFTs.jl package](https://juliamath.github.io/AbstractFFTs.jl/stable/api/#Public-Interface-1). Additional functionalities supported by the FFTW library are documented in the present package.

## MKL

Alternatively, the FFTs in Intel's Math Kernel Library (MKL) can be used
by running `FFTW.set_provider!("mkl")`. MKL will be provided through `MKL_jll`.
This change of provider is persistent and has to be done only once, i.e., the package will use MKL when building and updating. 
Note however that MKL provides only a subset of the functionality provided by FFTW. See
Intel's [documentation](https://software.intel.com/en-us/mkl-developer-reference-c-using-fftw3-wrappers)
for more information about potential differences or gaps in functionality. 
In case MKL does not fit the needs (anymore), `FFTW.set_provider!("fftw")` allows to revert the change of provider.


## License

The FFTW library will be downloaded on versions of Julia where it is no longer distributed
as part of Julia.
Note that FFTW is licensed under GPLv2 or higher (see
[its license file](http://www.fftw.org/doc/License-and-Copyright.html)), but the bindings
to the library in this package, FFTW.jl, are licensed under MIT.
This means that code using the FFTW library via the FFTW.jl bindings is subject to FFTW's
licensing terms.
Code using alternative implementations of the FFTW API, such as
[MKL's FFTW3 interface](https://software.intel.com/en-us/mkl-developer-reference-c-fftw3-interface-to-intel-math-kernel-library)
are instead subject to the alternative's license.
If you distribute a derived or combined work, i.e. a program that links to and is distributed
with the FFTW library, then that distribution falls under the terms of the GPL.
If you just distribute source code that links to FFTW.jl, and users have to download FFTW
or MKL to provide the backend, then the GPL probably doesn't have much effect on you.

# This file was formerly a part of Julia. License is MIT: https://julialang.org/license

import Base: show, *, convert, unsafe_convert, size, strides, ndims, pointer
import LinearAlgebra: mul!

"""
    r2r(A, kind [, dims])

Performs a multidimensional real-input/real-output (r2r) transform
of type `kind` of the array `A`, as defined in the FFTW manual.
`kind` specifies either a discrete cosine transform of various types
(`FFTW.REDFT00`, `FFTW.REDFT01`, `FFTW.REDFT10`, or
`FFTW.REDFT11`), a discrete sine transform of various types
(`FFTW.RODFT00`, `FFTW.RODFT01`, `FFTW.RODFT10`, or
`FFTW.RODFT11`), a real-input DFT with halfcomplex-format output
(`FFTW.R2HC` and its inverse `FFTW.HC2R`), or a discrete
Hartley transform (`FFTW.DHT`).  The `kind` argument may be
an array or tuple in order to specify different transform types
along the different dimensions of `A`; `kind[end]` is used
for any unspecified dimensions.  See the FFTW manual for precise
definitions of these transform types, at http://www.fftw.org/doc.

The optional `dims` argument specifies an iterable subset of
dimensions (e.g. an integer, range, tuple, or array) to transform
along. `kind[i]` is then the transform type for `dims[i]`,
with `kind[end]` being used for `i > length(kind)`.

See also [`plan_r2r`](@ref) to pre-plan optimized r2r transforms.
"""
function r2r end

"""
    r2r!(A, kind [, dims])

Same as [`r2r`](@ref), but operates in-place on `A`, which must be
an array of real or complex floating-point numbers.
"""
function r2r! end

"""
    plan_r2r!(A, kind [, dims [, flags [, timelimit [, num_threads]]]])

Similar to [`plan_fft`](@extref `AbstractFFTs.plan_fft`), but corresponds to [`r2r!`](@ref).
"""
function plan_r2r! end

"""
    plan_r2r(A, kind [, dims [, flags [, timelimit [, num_threads]]]])

Pre-plan an optimized r2r transform, similar to [`plan_fft`](@extref `AbstractFFTs.plan_fft`) except that the
transforms (and the first three arguments) correspond to [`r2r`](@ref) and [`r2r!`](@ref), respectively.
"""
function plan_r2r end

## FFT: Implement fft by calling fftw.

# TODO: this is dangerous since it captures runtime data from the compile machine
# n.b. write this as a function to avoid Julia bugs with the runtime cglobal implementation
get_version() = VersionNumber(split(unsafe_string(cglobal(
    (:fftw_version,libfftw3_no_init), UInt8)), ['-', ' '])[2])
const version = get_version()

## Direction of FFT

const FORWARD = -1
const BACKWARD = 1

## FFTW Flags from fftw3.h

const MEASURE         = UInt32(0)
const DESTROY_INPUT   = UInt32(1 << 0)
const UNALIGNED       = UInt32(1 << 1)
const CONSERVE_MEMORY = UInt32(1 << 2)
const EXHAUSTIVE      = UInt32(1 << 3)   # NO_EXHAUSTIVE is default
const PRESERVE_INPUT  = UInt32(1 << 4)   # cancels DESTROY_INPUT
const PATIENT         = UInt32(1 << 5)   # IMPATIENT is default
const ESTIMATE        = UInt32(1 << 6)
const WISDOM_ONLY     = UInt32(1 << 21)
const NO_SIMD = UInt32(1 << 17) # disable SIMD, useful for benchmarking

## R2R transform kinds

const R2HC    = 0
const HC2R    = 1
const DHT     = 2
const REDFT00 = 3
const REDFT01 = 4
const REDFT10 = 5
const REDFT11 = 6
const RODFT00 = 7
const RODFT01 = 8
const RODFT10 = 9
const RODFT11 = 10

let k2s = Dict(R2HC => "R2HC", HC2R => "HC2R", DHT => "DHT", REDFT00 => "REDFT00",
               REDFT01 => "REDFT01", REDFT10 => "REDFT10", REDFT11 => "REDFT11",
               RODFT00 => "RODFT00", RODFT01 => "RODFT01", RODFT10 => "RODFT10",
               RODFT11 => "RODFT11")
    global kind2string
    kind2string(k::Integer) = k2s[Int(k)]
end

# FFTW floating-point types:

const fftwNumber = Union{Float64,Float32,Complex{Float64},Complex{Float32}}
const fftwReal = Union{Float64,Float32}
const fftwComplex = Union{Complex{Float64},Complex{Float32}}
const fftwDouble = Union{Float64,Complex{Float64}}
const fftwSingle = Union{Float32,Complex{Float32}}
const fftwTypeDouble = Union{Type{Float64},Type{Complex{Float64}}}
const fftwTypeSingle = Union{Type{Float32},Type{Complex{Float32}}}

# For ESTIMATE plans, FFTW allows one to pass NULL for the array pointer,
# since it is not written to.  Hence, it is convenient to create an
# array-like type that carries a size and a stride like a "real" array
# but which is converted to C_NULL as a pointer.
struct FakeArray{T,N} <: DenseArray{T,N}
    sz::NTuple{N,Int}
    st::NTuple{N,Int}
end
size(a::FakeArray) = a.sz
strides(a::FakeArray) = a.st
unsafe_convert(::Type{Ptr{T}}, a::FakeArray{T}) where {T} = convert(Ptr{T}, C_NULL)
pointer(a::FakeArray{T}) where {T} = convert(Ptr{T}, C_NULL)
FakeArray{T}(sz::NTuple{N,Int}) where {T,N} = FakeArray{T,N}(sz, colmajorstrides(sz))
FakeArray{T}(sz::Int...) where {T} = FakeArray{T}(sz)
fakesimilar(flags, X, T) = flags & ESTIMATE != 0 ? FakeArray{T}(size(X)) : Array{T}(undef, size(X))
alignment_of(A::FakeArray) = Int32(0)

## Julia wrappers around FFTW functions

# Wisdom

# Import and export wisdom to/from a single file for all precisions,
# which is more user-friendly than requiring the user to call a
# separate routine depending on the fp precision of the plans.  This
# requires a bit of trickiness since we have to (a) use the libc file
# I/O routines with fftw_export_wisdom_to_file/import_wisdom_from_file
# (b) we need 256 bytes of space padding between the wisdoms to work
# around FFTW's internal file i/o buffering [see the BUFSZ constant in
# FFTW's api/import-wisdom-from-file.c file].

@exclusive function export_wisdom(fname::AbstractString)
    f = ccall(:fopen, Ptr{Cvoid}, (Cstring,Cstring), fname, :w)
    systemerror("could not open wisdom file $fname for writing", f == C_NULL)
    ccall((:fftw_export_wisdom_to_file,libfftw3), Cvoid, (Ptr{Cvoid},), f)
    ccall(:fputs, Int32, (Ptr{UInt8},Ptr{Cvoid}), " "^256, f) # no NUL, hence no Cstring
    ccall((:fftwf_export_wisdom_to_file,libfftw3f), Cvoid, (Ptr{Cvoid},), f)
    ccall(:fclose, Cvoid, (Ptr{Cvoid},), f)
end

@exclusive function import_wisdom(fname::AbstractString)
    f = ccall(:fopen, Ptr{Cvoid}, (Cstring,Cstring), fname, :r)
    systemerror("could not open wisdom file $fname for reading", f == C_NULL)
    if ccall((:fftw_import_wisdom_from_file,libfftw3),Int32,(Ptr{Cvoid},),f)==0||
       ccall((:fftwf_import_wisdom_from_file,libfftw3f),Int32,(Ptr{Cvoid},),f)==0
        error("failed to import wisdom from $fname")
    end
    ccall(:fclose, Cvoid, (Ptr{Cvoid},), f)
end

@exclusive function import_system_wisdom()
    if ccall((:fftw_import_system_wisdom,libfftw3), Int32, ()) == 0 ||
       ccall((:fftwf_import_system_wisdom,libfftw3f), Int32, ()) == 0
        error("failed to import system wisdom")
    end
end

@exclusive function forget_wisdom()
    ccall((:fftw_forget_wisdom,libfftw3), Cvoid, ())
    ccall((:fftwf_forget_wisdom,libfftw3f), Cvoid, ())
end

# Threads

# Must only be called after acquiring fftwlock
function _set_num_threads(num_threads::Integer)
    @static if fftw_provider == "mkl"
        _last_num_threads[] = num_threads
    end
    ccall((:fftw_plan_with_nthreads,libfftw3), Cvoid, (Int32,), num_threads)
    ccall((:fftwf_plan_with_nthreads,libfftw3f), Cvoid, (Int32,), num_threads)
end

@exclusive set_num_threads(num_threads::Integer) = _set_num_threads(num_threads)

function get_num_threads()
    @static if fftw_provider == "fftw"
        ccall((:fftw_planner_nthreads,libfftw3), Cint, ())
    else
        _last_num_threads[]
    end
end

@exclusive function set_num_threads(f::Function, num_threads::Integer)
    orig_num_threads = get_num_threads()
    _set_num_threads(num_threads)
    try
        f()
    finally
        _set_num_threads(orig_num_threads)
    end
end

# pointer type for fftw_plan (opaque pointer)

struct fftw_plan_struct end
const PlanPtr = Ptr{fftw_plan_struct}

# Planner timelimits

const NO_TIMELIMIT = -1.0 # from fftw3.h

# only call these when fftwlock is held:
unsafe_set_timelimit(precision::fftwTypeDouble,seconds) =
    ccall((:fftw_set_timelimit,libfftw3), Cvoid, (Float64,), seconds)
unsafe_set_timelimit(precision::fftwTypeSingle,seconds) =
    ccall((:fftwf_set_timelimit,libfftw3f), Cvoid, (Float64,), seconds)
@exclusive set_timelimit(precision, seconds) = unsafe_set_timelimit(precision, seconds)

# Array alignment mod 16:
#   FFTW plans may depend on the alignment of the array mod 16 bytes,
#   i.e. the address mod 16 of the first element of the array, in order
#   to exploit SIMD operations.  Julia arrays are, by default, aligned
#   to 16-byte boundaries (address mod 16 == 0), but this may not be
#   true for data imported from external C code, or for SubArrays.
#   Use the undocumented routine fftw_alignment_of to determine the
#   alignment of a given pointer modulo whatever FFTW needs; this
#   function will be documented in FFTW 3.3.4.


@static if fftw_provider == "mkl"
    alignment_of(A::StridedArray{<:fftwDouble}) =
        convert(Int32, convert(Int64, pointer(A)) % 16)
    alignment_of(A::StridedArray{<:fftwSingle}) =
        convert(Int32, convert(Int64, pointer(A)) % 16)
else
    alignment_of(A::StridedArray{T}) where {T<:fftwDouble} =
        ccall((:fftw_alignment_of, libfftw3), Int32, (Ptr{T},), A)
    alignment_of(A::StridedArray{T}) where {T<:fftwSingle} =
        ccall((:fftwf_alignment_of, libfftw3f), Int32, (Ptr{T},), A)
end

# FFTWPlan (low-level)

# low-level storage of the FFTW plan, along with the information
# needed to determine whether it is applicable.   We need to put
# this into a type to support a finalizer on the fftw_plan.
# K is FORWARD/BACKWARD for forward/backward or r2c/c2r plans, respectively.
# For r2r plans, the field kinds::K is a tuple/vector of the transform kinds along each dimension.
abstract type FFTWPlan{T<:fftwNumber,K,inplace} <: Plan{T} end
for P in (:cFFTWPlan, :rFFTWPlan) # complex, r2c/c2r
    @eval begin
        mutable struct $P{T<:fftwNumber,K,inplace,N,G} <: FFTWPlan{T,K,inplace}
            plan::PlanPtr
            sz::NTuple{N,Int} # size of array on which plan operates (Int tuple)
            osz::NTuple{N,Int} # size of output array (Int tuple)
            istride::NTuple{N,Int} # strides of input
            ostride::NTuple{N,Int} # strides of output
            ialign::Int32 # alignment mod 16 of input
            oalign::Int32 # alignment mod 16 of input
            flags::UInt32 # planner flags
            region::G # region (iterable) of dims that are transformed
            pinv::ScaledPlan
            function $P{T,K,inplace,N,G}(plan::PlanPtr, flags::Integer, R::G,
                                         X::StridedArray{T,N}, Y::StridedArray) where {T<:fftwNumber,K,inplace,N,G}
                p = new(plan, size(X), size(Y), strides(X), strides(Y),
                        alignment_of(X), alignment_of(Y), flags, R)
                finalizer(maybe_destroy_plan, p)
                p
            end
        end

        function $P{T,K,inplace,N}(plan::PlanPtr, flags::Integer, R::G,
                                   X::StridedArray{T,N},
                                   Y::StridedArray) where {T<:fftwNumber,K,inplace,N,G}
            $P{T,K,inplace,N,G}(plan, flags, R, X, Y)
        end
    end
end

mutable struct r2rFFTWPlan{T<:fftwNumber,K,inplace,N,G} <: FFTWPlan{T,K,inplace}
    plan::PlanPtr
    sz::NTuple{N,Int} # size of array on which plan operates (Int tuple)
    osz::NTuple{N,Int} # size of output array (Int tuple)
    istride::NTuple{N,Int} # strides of input
    ostride::NTuple{N,Int} # strides of output
    ialign::Int32 # alignment mod 16 of input
    oalign::Int32 # alignment mod 16 of input
    flags::UInt32 # planner flags
    region::G # region (iterable) of dims that are transformed
    kinds::K
    pinv::ScaledPlan
    function r2rFFTWPlan{T,K,inplace,N,G}(plan::PlanPtr, flags::Integer, R::G,
                                 X::StridedArray{T,N},
                                 Y::StridedArray, kinds::K) where {T<:fftwNumber,K,inplace,N,G}
        p = new(plan, size(X), size(Y), strides(X), strides(Y),
                alignment_of(X), alignment_of(Y), flags, R, kinds)
        finalizer(maybe_destroy_plan, p)
        p
    end
end

function r2rFFTWPlan{T,K,inplace,N}(plan::PlanPtr, flags::Integer, R::G,
                           X::StridedArray{T,N},
                           Y::StridedArray, kinds::K) where {T<:fftwNumber,K,inplace,N,G}
    r2rFFTWPlan{T,K,inplace,N,G}(plan, flags, R, X, Y, kinds)
end

size(p::FFTWPlan) = p.sz

unsafe_convert(::Type{PlanPtr}, p::FFTWPlan) = p.plan

#################################################################################################
# We have to be careful about destroying plans in an FFTWPlan finalizer, because the
# garbage-collector may run at unexpected times.  For example, it may run during the spawnloop
# callback while the FFTW planner is executing.  Under these circumstances, the garbage collector
# may deadlock if it needs to acquire the fftwlock (already held by the planning thread via @exclusive).
# Instead, if islocked(fftwlock), we defer plan destruction until the fftwlock is released, by
# pushing the plan to be destroyed to the deferred_destroy_plans (which itself is protected by a lock).
# This is accomplished by the maybe_destroy_plan function, which is used as the plan finalizer.

# these functions should only be called while the fftwlock is held
unsafe_destroy_plan(@nospecialize(plan::FFTWPlan{<:fftwDouble})) =
    ccall((:fftw_destroy_plan,libfftw3), Cvoid, (PlanPtr,), plan)
unsafe_destroy_plan(@nospecialize(plan::FFTWPlan{<:fftwSingle})) =
    ccall((:fftwf_destroy_plan,libfftw3f), Cvoid, (PlanPtr,), plan)

const deferred_destroy_lock = ReentrantLock() # lock protecting the deferred_destroy_plans list
const deferred_destroy_plans = FFTWPlan[]

function destroy_deferred()
    lock(deferred_destroy_lock)
    try
        # need trylock here to avoid potential deadlocks if another
        # @exclusive function has just grabbed the lock; in that case,
        # we'll do nothing (the other function will eventually run destroy_deferred).
        if !isempty(deferred_destroy_plans) && trylock(fftwlock)
            try
                @inline foreach(unsafe_destroy_plan, deferred_destroy_plans)
                empty!(deferred_destroy_plans)
            finally
                unlock(fftwlock)
            end
        end
    finally
        unlock(deferred_destroy_lock)
    end
end

@exclusive destroy_plan(plan::FFTWPlan) = unsafe_destroy_plan(plan)

function maybe_destroy_plan(plan::FFTWPlan)
    # need to acquire deferred_destroy_lock before trylock to avoid a memory leak
    # (race to avoid: trylock == false, other thread unlocks and calls destroy_deferred,
    #                 then we push a deferred plan that may never get freed)
    # Also, we need to use a trylock spinloop rather than lock(deferred_destroy_lock),
    # since task switches aren't permitted in finalizers.   This has suboptimal efficiency,
    # but we shouldn't waste too many cycles since destroying plans is quick and contention
    # should be rare.
    while !trylock(deferred_destroy_lock)
        # Need a safepoint in here because without it, this loop blocks forward progress in the GC and can deadlock
        # the program.
        GC.safepoint()
    end
    try
        # note: fftwlock is re-entrant, so trylock will succeed here if we
        # are in the task that holds the planner lock.  That's okay — 
        # re-entrant calls to destroy_plan in the planner thread
        # should be fine as long as we didn't call make_planner_thread_safe.
        if trylock(fftwlock)
            try
                unsafe_destroy_plan(plan)
            finally
                unlock(fftwlock)
            end
        else
            push!(deferred_destroy_plans, plan)
        end
    finally
        unlock(deferred_destroy_lock)
    end
end

#################################################################################################

cost(plan::FFTWPlan{<:fftwDouble}) =
    ccall((:fftw_cost,libfftw3), Float64, (PlanPtr,), plan)
cost(plan::FFTWPlan{<:fftwSingle}) =
    ccall((:fftwf_cost,libfftw3f), Float64, (PlanPtr,), plan)

@exclusive function arithmetic_ops(plan::FFTWPlan{<:fftwDouble})
    add, mul, fma = Ref(0.0), Ref(0.0), Ref(0.0)
    ccall((:fftw_flops,libfftw3), Cvoid,
          (PlanPtr,Ref{Float64},Ref{Float64},Ref{Float64}), plan, add, mul, fma)
    return (round(Int64, add[]), round(Int64, mul[]), round(Int64, fma[]))
end
@exclusive function arithmetic_ops(plan::FFTWPlan{<:fftwSingle})
    add, mul, fma = Ref(0.0), Ref(0.0), Ref(0.0)
    ccall((:fftwf_flops,libfftw3f), Cvoid,
          (PlanPtr,Ref{Float64},Ref{Float64},Ref{Float64}), plan, add, mul, fma)
    return (round(Int64, add[]), round(Int64, mul[]), round(Int64, fma[]))
end
flops(plan::FFTWPlan) = let ops = arithmetic_ops(plan)
    ops[1] + ops[2] + 2 * ops[3] # add + mul + 2*fma
end

# Pretty-printing plans

function showfftdims(io, sz::Dims, istride::Dims, T)
    if isempty(sz)
        print(io, "0-dimensional")
    elseif length(sz) == 1
        print(io, sz[1], "-element")
    else
        print(io, join(sz, "×"))
    end
    if istride == colmajorstrides(sz)
        print(io, " array of ", T)
    else
        print(io, " $istride-strided array of ", T)
    end
end

# The sprint_plan function was released in FFTW 3.3.4, but MKL versions
# claiming to be FFTW 3.3.4 still don't seem to have this function.
const has_sprint_plan = version >= v"3.3.4" && fftw_provider == "fftw"

@static if has_sprint_plan
    sprint_plan_(plan::FFTWPlan{<:fftwDouble}) =
        ccall((:fftw_sprint_plan,libfftw3), Ptr{UInt8}, (PlanPtr,), plan)
    sprint_plan_(plan::FFTWPlan{<:fftwSingle}) =
        ccall((:fftwf_sprint_plan,libfftw3f), Ptr{UInt8}, (PlanPtr,), plan)
    function sprint_plan(plan::FFTWPlan)
        p = sprint_plan_(plan)
        str = unsafe_string(p)
        Libc.free(p)
        return str
    end
else
    sprint_plan(plan::FFTWPlan) = ""
end

function show(io::IO, p::cFFTWPlan{T,K,inplace}) where {T,K,inplace}
    print(io, inplace ? "FFTW in-place " : "FFTW ",
          K < 0 ? "forward" : "backward", " plan for ")
    showfftdims(io, p.sz, p.istride, T)
    has_sprint_plan && print(io, "\n", sprint_plan(p))
end

function show(io::IO, p::rFFTWPlan{T,K,inplace}) where {T,K,inplace}
    print(io, inplace ? "FFTW in-place " : "FFTW ",
          K < 0 ? "real-to-complex" : "complex-to-real",
          " plan for ")
    showfftdims(io, p.sz, p.istride, T)
    has_sprint_plan && print(io, "\n", sprint_plan(p))
end

function show(io::IO, p::r2rFFTWPlan{T,K,inplace}) where {T,K,inplace}
    kinds = p.kinds
    print(io, inplace ? "FFTW in-place r2r " : "FFTW r2r ")
    if isempty(kinds)
        print(io, "0-dimensional")
    elseif kinds == ntuple(i -> kinds[1], length(kinds))
        print(io, kind2string(kinds[1]))
        if length(kinds) > 1
            print(io, "^", length(kinds))
        end
    else
        print(io, join(map(kind2string, kinds), "×"))
    end
    print(io, " plan for ")
    showfftdims(io, p.sz, p.istride, T)
    has_sprint_plan && print(io, "\n", sprint_plan(p))
end

# Check whether a FFTWPlan is applicable to a given input array, and
# throw an informative error if not:
function assert_applicable(p::FFTWPlan{T}, X::StridedArray{T}) where T
    if size(X) != p.sz
        throw(ArgumentError("FFTW plan applied to wrong-size array"))
    elseif strides(X) != p.istride
        throw(ArgumentError("FFTW plan applied to wrong-strides array"))
    elseif alignment_of(X) != p.ialign && p.flags & UNALIGNED == 0
        throw(ArgumentError("FFTW plan applied to array with wrong memory alignment"))
    end
end

function assert_applicable(p::FFTWPlan{T,K,inplace}, X::StridedArray{T}, Y::StridedArray) where {T,K,inplace}
    assert_applicable(p, X)
    if size(Y) != p.osz
        throw(ArgumentError("FFTW plan applied to wrong-size output"))
    elseif strides(Y) != p.ostride
        throw(ArgumentError("FFTW plan applied to wrong-strides output"))
    elseif alignment_of(Y) != p.oalign && p.flags & UNALIGNED == 0
        throw(ArgumentError("FFTW plan applied to output with wrong memory alignment"))
    elseif inplace != (pointer(X) == pointer(Y))
        throw(ArgumentError(string("FFTW ",
                                   inplace ? "in-place" : "out-of-place",
                                   " plan applied to ",
                                   inplace ? "out-of-place" : "in-place",
                                   " data")))
    end
end

# strides for a column-major (Julia-style) array of size == sz
colmajorstrides(::Tuple{}) = ()
colmajorstrides(sz) = _colmajorstrides(1, sz...)
@inline _colmajorstrides(p, sz1, tail...) = (p, _colmajorstrides(p*sz1, tail...)...)
_colmajorstrides(p) = ()

# Execute

unsafe_execute!(plan::FFTWPlan{<:fftwDouble}) =
    ccall((:fftw_execute,libfftw3), Cvoid, (PlanPtr,), plan)

unsafe_execute!(plan::FFTWPlan{<:fftwSingle}) =
    ccall((:fftwf_execute,libfftw3f), Cvoid, (PlanPtr,), plan)

unsafe_execute!(plan::cFFTWPlan{T},
                X::StridedArray{T}, Y::StridedArray{T}) where {T<:fftwDouble} =
    ccall((:fftw_execute_dft,libfftw3), Cvoid,
          (PlanPtr,Ptr{T},Ptr{T}), plan, X, Y)

unsafe_execute!(plan::cFFTWPlan{T},
                X::StridedArray{T}, Y::StridedArray{T}) where {T<:fftwSingle} =
    ccall((:fftwf_execute_dft,libfftw3f), Cvoid,
          (PlanPtr,Ptr{T},Ptr{T}), plan, X, Y)

unsafe_execute!(plan::rFFTWPlan{Float64,FORWARD},
                X::StridedArray{Float64}, Y::StridedArray{Complex{Float64}}) =
    ccall((:fftw_execute_dft_r2c,libfftw3), Cvoid,
          (PlanPtr,Ptr{Float64},Ptr{Complex{Float64}}), plan, X, Y)

unsafe_execute!(plan::rFFTWPlan{Float32,FORWARD},
                X::StridedArray{Float32}, Y::StridedArray{Complex{Float32}}) =
    ccall((:fftwf_execute_dft_r2c,libfftw3f), Cvoid,
          (PlanPtr,Ptr{Float32},Ptr{Complex{Float32}}), plan, X, Y)

unsafe_execute!(plan::rFFTWPlan{Complex{Float64},BACKWARD},
                X::StridedArray{Complex{Float64}}, Y::StridedArray{Float64}) =
    ccall((:fftw_execute_dft_c2r,libfftw3), Cvoid,
          (PlanPtr,Ptr{Complex{Float64}},Ptr{Float64}), plan, X, Y)

unsafe_execute!(plan::rFFTWPlan{Complex{Float32},BACKWARD},
                X::StridedArray{Complex{Float32}}, Y::StridedArray{Float32}) =
    ccall((:fftwf_execute_dft_c2r,libfftw3f), Cvoid,
          (PlanPtr,Ptr{Complex{Float32}},Ptr{Float32}), plan, X, Y)

unsafe_execute!(plan::r2rFFTWPlan{T},
                X::StridedArray{T}, Y::StridedArray{T}) where {T<:fftwDouble} =
    ccall((:fftw_execute_r2r,libfftw3), Cvoid,
          (PlanPtr,Ptr{T},Ptr{T}), plan, X, Y)

unsafe_execute!(plan::r2rFFTWPlan{T},
                X::StridedArray{T}, Y::StridedArray{T}) where {T<:fftwSingle} =
    ccall((:fftwf_execute_r2r,libfftw3f), Cvoid,
          (PlanPtr,Ptr{T},Ptr{T}), plan, X, Y)

# NOTE ON GC (garbage collection):
#    The FFTWPlan has a finalizer so that gc will destroy the plan,
#    which is necessary for gc to work with plan_fft.  However,
#    even when we are creating a single-use FFTWPlan [e.g. for fftn(x)],
#    we intentionally do NOT call destroy_plan explicitly, and instead
#    wait for garbage collection.  The reason is that, in the common
#    case where the user calls fft(x) a second time soon afterwards,
#    if destroy_plan has not yet been called then FFTW will internally
#    re-use the table of trigonometric constants from the first plan.

# Compute dims and howmany for FFTW guru planner
_anyrepeated(::Union{Number, AbstractUnitRange}) = false
function _anyrepeated(region)
    any(region) do x
        count(==(x), region) > 1
    end
end

# Utility methods to reduce allocations in dims_howmany
@inline _setindex(oreg, v, n) = (oreg[n] = v; oreg)
@inline _setindex(oreg::Tuple, v, n) = Base.setindex(oreg, v, n)
@inline _filtercoll(region::Union{Int, Tuple}, len) = ntuple(zero, len)
@inline _filtercoll(region, len) = Vector{Int}(undef, len)
# Optimized filter(∉(region), 1:ndims(X))
function _filter_notin_region(region, ::Val{ndimsX}) where {ndimsX}
    oreg = _filtercoll(region, ndimsX - length(region))
    n = 1
    for dim in 1:ndimsX
        dim in region && continue
        oreg = _setindex(oreg, dim, n)
        n += 1
    end
    oreg
end
function dims_howmany(X::StridedArray, Y::StridedArray, sz, region)
    if _anyrepeated(region)
        throw(ArgumentError("each dimension can be transformed at most once"))
    end
    ist = strides(X)
    ost = strides(Y)
    dims = Matrix{Int}(undef, 3, length(region))
    for (ind, i) in enumerate(region)
        dims[1, ind] = sz[i]
        dims[2, ind] = ist[i]
        dims[3, ind] = ost[i]
    end

    oreg = _filter_notin_region(region, Val(ndims(X)))
    howmany = Matrix{Int}(undef, 3, length(oreg))
    for (ind, i) in enumerate(oreg)
        howmany[1, ind] = sz[i]
        howmany[2, ind] = ist[i]
        howmany[3, ind] = ost[i]
    end

    return dims, howmany
end

function fix_kinds(region, kinds)
    if length(kinds) != length(region)
        if length(kinds) > length(region)
            throw(ArgumentError("too many transform kinds"))
        else
            if isempty(kinds)
                throw(ArgumentError("must supply a transform kind"))
            end
            k = Vector{Int32}(undef, length(region))
            copyto!(k, kinds)
            k[length(kinds)+1:end] .= kinds[end]
        end
    else
        k = Vector{Int32}(undef, length(kinds))
        k .= kinds
    end
    if any(x -> x < 0 || x > 10, k)
        throw(ArgumentError("invalid transform kind"))
    end
    return k
end

_circshiftmin1(v) = circshift(collect(Int, v), -1)
_circshiftmin1(t::Tuple) = (t[2:end]..., t[1])
_circshiftmin1(x::Integer) = x

# low-level FFTWPlan creation (for internal use in FFTW module)
for (Tr,Tc,fftw,lib) in ((:Float64,:(Complex{Float64}),"fftw",:libfftw3),
                         (:Float32,:(Complex{Float32}),"fftwf",:libfftw3f))
    @eval @exclusive function cFFTWPlan{$Tc,K,inplace,N}(X::StridedArray{$Tc,N},
                                              Y::StridedArray{$Tc,N},
                                              region, flags::Integer, timelimit::Real) where {K,inplace,N}
        direction = K
        unsafe_set_timelimit($Tr, timelimit)
        R = isa(region, Tuple) ? region : copy(region)
        dims, howmany = dims_howmany(X, Y, size(X), R)
        plan = ccall(($(string(fftw,"_plan_guru64_dft")),$lib),
                     PlanPtr,
                     (Int32, Ptr{Int}, Int32, Ptr{Int},
                      Ptr{$Tc}, Ptr{$Tc}, Int32, UInt32),
                     size(dims,2), dims, size(howmany,2), howmany,
                     X, Y, direction, flags)
        unsafe_set_timelimit($Tr, NO_TIMELIMIT)
        if plan == C_NULL
            error("FFTW could not create plan") # shouldn't normally happen
        end
        return cFFTWPlan{$Tc,K,inplace,N}(plan, flags, R, X, Y)
    end

    @eval @exclusive function rFFTWPlan{$Tr,$FORWARD,inplace,N}(X::StridedArray{$Tr,N},
                                                     Y::StridedArray{$Tc,N},
                                                     region, flags::Integer, timelimit::Real) where {inplace,N}
        R = isa(region, Tuple) ? region : copy(region)
        regionshft = _circshiftmin1(region) # FFTW halves last dim
        unsafe_set_timelimit($Tr, timelimit)
        dims, howmany = dims_howmany(X, Y, size(X), regionshft)
        plan = ccall(($(string(fftw,"_plan_guru64_dft_r2c")),$lib),
                     PlanPtr,
                     (Int32, Ptr{Int}, Int32, Ptr{Int},
                      Ptr{$Tr}, Ptr{$Tc}, UInt32),
                     size(dims,2), dims, size(howmany,2), howmany,
                     X, Y, flags)
        unsafe_set_timelimit($Tr, NO_TIMELIMIT)
        if plan == C_NULL
            error("FFTW could not create plan") # shouldn't normally happen
        end
        return rFFTWPlan{$Tr,$FORWARD,inplace,N}(plan, flags, R, X, Y)
    end

    @eval @exclusive function rFFTWPlan{$Tc,$BACKWARD,inplace,N}(X::StridedArray{$Tc,N},
                                                      Y::StridedArray{$Tr,N},
                                                      region, flags::Integer, timelimit::Real) where {inplace,N}
        R = isa(region, Tuple) ? region : copy(region)
        regionshft = _circshiftmin1(region) # FFTW halves last dim
        unsafe_set_timelimit($Tr, timelimit)
        dims, howmany = dims_howmany(X, Y, size(Y), regionshft)
        plan = ccall(($(string(fftw,"_plan_guru64_dft_c2r")),$lib),
                     PlanPtr,
                     (Int32, Ptr{Int}, Int32, Ptr{Int},
                      Ptr{$Tc}, Ptr{$Tr}, UInt32),
                     size(dims,2), dims, size(howmany,2), howmany,
                     X, Y, flags)
        unsafe_set_timelimit($Tr, NO_TIMELIMIT)
        if plan == C_NULL
            error("FFTW could not create plan") # shouldn't normally happen
        end
        return rFFTWPlan{$Tc,$BACKWARD,inplace,N}(plan, flags, R, X, Y)
    end

    @eval @exclusive function r2rFFTWPlan{$Tr,Any,inplace,N}(X::StridedArray{$Tr,N},
                                                  Y::StridedArray{$Tr,N},
                                                  region, kinds, flags::Integer,
                                                  timelimit::Real) where {inplace,N}

        R = isa(region, Tuple) ? region : copy(region)
        knd = fix_kinds(region, kinds)
        unsafe_set_timelimit($Tr, timelimit)
        dims, howmany = dims_howmany(X, Y, size(X), region)
        plan = ccall(($(string(fftw,"_plan_guru64_r2r")),$lib),
                     PlanPtr,
                     (Int32, Ptr{Int}, Int32, Ptr{Int},
                      Ptr{$Tr}, Ptr{$Tr}, Ptr{Int32}, UInt32),
                     size(dims,2), dims, size(howmany,2), howmany,
                     X, Y, knd, flags)
        unsafe_set_timelimit($Tr, NO_TIMELIMIT)
        if plan == C_NULL
            error("FFTW could not create plan") # shouldn't normally happen
        end
        r2rFFTWPlan{$Tr,typeof(knd),inplace,N}(plan, flags, R, X, Y, knd)
    end

    # support r2r transforms of complex = transforms of real & imag parts
    @eval @exclusive function r2rFFTWPlan{$Tc,Any,inplace,N}(X::StridedArray{$Tc,N},
                                                  Y::StridedArray{$Tc,N},
                                                  region, kinds, flags::Integer,
                                                  timelimit::Real) where {inplace,N}

        R = isa(region, Tuple) ? region : copy(region)
        knd = fix_kinds(region, kinds)
        unsafe_set_timelimit($Tr, timelimit)
        dims, howmany = dims_howmany(X, Y, size(X), region)
        @views begin
            dims[2:3, :] .*= 2
            howmany[2:3, :] .*= 2
        end
        howmany = [howmany [2,1,1]] # append loop over real/imag parts
        plan = ccall(($(string(fftw,"_plan_guru64_r2r")),$lib),
                     PlanPtr,
                     (Int32, Ptr{Int}, Int32, Ptr{Int},
                      Ptr{$Tc}, Ptr{$Tc}, Ptr{Int32}, UInt32),
                     size(dims,2), dims, size(howmany,2), howmany,
                     X, Y, knd, flags)
        unsafe_set_timelimit($Tr, NO_TIMELIMIT)
        if plan == C_NULL
            error("FFTW could not create plan") # shouldn't normally happen
        end
        r2rFFTWPlan{$Tc,typeof(knd),inplace,N}(plan, flags, R, X, Y, knd)
    end
end

# Convert arrays of numeric types to FFTW-supported packed complex-float types
# (FIXME: is there a way to use the Julia promotion rules more cleverly here?)
fftwcomplex(X::StridedArray{<:fftwComplex}) = X
fftwcomplex(X::AbstractArray{T}) where {T<:fftwReal} =
    copyto!(Array{typeof(complex(zero(T)))}(undef, size(X)), X)
fftwcomplex(X::AbstractArray{<:Real}) = copyto!(Array{Complex{Float64}}(undef, size(X)),X)
fftwcomplex(X::AbstractArray{<:Complex}) = copyto!(Array{Complex{Float64}}(undef, size(X)), X)
fftwfloat(X::StridedArray{<:fftwReal}) = X
fftwfloat(X::AbstractArray{<:Real}) = copyto!(Array{Float64}(undef, size(X)), X)
fftwfloat(X::AbstractArray{<:Complex}) = fftwcomplex(X)

for (f,direction) in ((:fft,FORWARD), (:bfft,BACKWARD))
    plan_f = Symbol("plan_",f)
    plan_f! = Symbol("plan_",f,"!")
    idirection = -direction
    @eval begin
        function $plan_f(X::StridedArray{T,N}, region;
                         flags::Integer=ESTIMATE,
                         timelimit::Real=NO_TIMELIMIT,
                         num_threads::Union{Nothing, Integer} = nothing) where {T<:fftwComplex,N}
            if num_threads !== nothing
                plan = set_num_threads(num_threads) do
                    $plan_f(X, region; flags = flags, timelimit = timelimit)
                end
                return plan
            end
            cFFTWPlan{T,$direction,false,N}(X, fakesimilar(flags, X, T),
                                            region, flags, timelimit)
        end

        function $plan_f!(X::StridedArray{T,N}, region;
                          flags::Integer=ESTIMATE,
                          timelimit::Real=NO_TIMELIMIT,
                          num_threads::Union{Nothing, Integer} = nothing ) where {T<:fftwComplex,N}
            if num_threads !== nothing
                plan = set_num_threads(num_threads) do
                    $plan_f!(X, region; flags = flags, timelimit = timelimit)
                end
                return plan
            end
            cFFTWPlan{T,$direction,true,N}(X, X, region, flags, timelimit)
        end
        $plan_f(X::StridedArray{<:fftwComplex}; kws...) =
            $plan_f(X, ntuple(identity, ndims(X)); kws...)
        $plan_f!(X::StridedArray{<:fftwComplex}; kws...) =
            $plan_f!(X, ntuple(identity, ndims(X)); kws...)

        function plan_inv(p::cFFTWPlan{T,$direction,inplace,N};
                          num_threads::Union{Nothing, Integer} = nothing) where {T<:fftwComplex,N,inplace}
            if num_threads !== nothing
                plan = set_num_threads(num_threads) do
                    plan_inv(p)
                end
                return plan
            end
            X = Array{T}(undef, p.sz)
            Y = inplace ? X : fakesimilar(p.flags, X, T)
            ScaledPlan(cFFTWPlan{T,$idirection,inplace,N}(X, Y, p.region,
                                                          p.flags, NO_TIMELIMIT),
                       normalization(X, p.region))
        end
    end
end

function mul!(y::StridedArray{T}, p::cFFTWPlan{T}, x::StridedArray{T}) where T
    assert_applicable(p, x, y)
    unsafe_execute!(p, x, y)
    return y
end

function *(p::cFFTWPlan{T,K,false}, x::StridedArray{T,N}) where {T,K,N}
    assert_applicable(p, x)
    y = Array{T}(undef, p.osz)::Array{T,N}
    unsafe_execute!(p, x, y)
    return y
end

function *(p::cFFTWPlan{T,K,true}, x::StridedArray{T}) where {T,K}
    assert_applicable(p, x)
    unsafe_execute!(p, x, x)
    return x
end

# rfft/brfft and planned variants.  No in-place version for now.

for (Tr,Tc) in ((:Float32,:(Complex{Float32})),(:Float64,:(Complex{Float64})))
    # Note: use $FORWARD and $BACKWARD below because of issue #9775
    @eval begin
        function plan_rfft(X::StridedArray{$Tr,N}, region;
                           flags::Integer=ESTIMATE,
                           timelimit::Real=NO_TIMELIMIT,
                           num_threads::Union{Nothing, Integer} = nothing) where N
            if num_threads !== nothing
                plan = set_num_threads(num_threads) do
                    plan_rfft(X, region; flags = flags, timelimit = timelimit)
                end
                return plan
            end
            osize = rfft_output_size(X, region)
            Y = flags&ESTIMATE != 0 ? FakeArray{$Tc}(osize) : Array{$Tc}(undef, osize)
            rFFTWPlan{$Tr,$FORWARD,false,N}(X, Y, region, flags, timelimit)
        end

        function plan_brfft(X::StridedArray{$Tc,N}, d::Integer, region;
                            flags::Integer=ESTIMATE,
                            timelimit::Real=NO_TIMELIMIT,
                            num_threads::Union{Nothing, Integer} = nothing) where N
            if num_threads !== nothing
                plan = set_num_threads(num_threads) do
                    plan_brfft(X, d, region; flags = flags, timelimit = timelimit)
                end
                return plan
            end
            osize = brfft_output_size(X, d, region)
            Y = flags&ESTIMATE != 0 ? FakeArray{$Tr}(osize) : Array{$Tr}(undef, osize)

            # FFTW currently doesn't support PRESERVE_INPUT for
            # multidimensional out-of-place c2r transforms, so
            # we have to handle 1d and >1d cases separately with a copy.  Ugh.
            if length(region) <= 1
                rFFTWPlan{$Tc,$BACKWARD,false,N}(X, Y, region,
                                                 flags | PRESERVE_INPUT,
                                                 timelimit)
            else
                rFFTWPlan{$Tc,$BACKWARD,false,N}(copy(X), Y, region, flags,
                                                 timelimit)
            end
        end

        plan_rfft(X::StridedArray{$Tr};kws...)=plan_rfft(X,ntuple(identity, ndims(X));kws...)
        plan_brfft(X::StridedArray{$Tr};kws...)=plan_brfft(X,ntuple(identity, ndims(X));kws...)

        function plan_inv(p::rFFTWPlan{$Tr,$FORWARD,false,N},
                          num_threads::Union{Nothing, Integer} = nothing) where N
            if num_threads !== nothing
                plan = set_num_threads(num_threads) do
                    plan_inv(p)
                end
                return plan
            end
            X = Array{$Tr}(undef, p.sz)
            Y = p.flags&ESTIMATE != 0 ? FakeArray{$Tc}(p.osz) : Array{$Tc}(undef, p.osz)
            ScaledPlan(rFFTWPlan{$Tc,$BACKWARD,false,N}(Y, X, p.region,
                                                        length(p.region) <= 1 ?
                                                        p.flags | PRESERVE_INPUT :
                                                        p.flags, NO_TIMELIMIT),
                       normalization(X, p.region))
        end

        function plan_inv(p::rFFTWPlan{$Tc,$BACKWARD,false,N};
                          num_threads::Union{Nothing, Integer} = nothing) where N
            if num_threads !== nothing
                plan = set_num_threads(num_threads) do
                    plan_inv(p)
                end
                return plan
            end
            X = Array{$Tc}(undef, p.sz)
            Y = p.flags&ESTIMATE != 0 ? FakeArray{$Tr}(p.osz) : Array{$Tr}(undef, p.osz)
            ScaledPlan(rFFTWPlan{$Tr,$FORWARD,false,N}(Y, X, p.region,
                                                       p.flags, NO_TIMELIMIT),
                       normalization(Y, p.region))
        end

        function mul!(y::StridedArray{$Tc}, p::rFFTWPlan{$Tr,$FORWARD}, x::StridedArray{$Tr})
            assert_applicable(p, x, y)
            unsafe_execute!(p, x, y)
            return y
        end
        function mul!(y::StridedArray{$Tr}, p::rFFTWPlan{$Tc,$BACKWARD}, x::StridedArray{$Tc})
            assert_applicable(p, x, y)
            unsafe_execute!(p, x, y) # note: may overwrite x as well as y!
            return y
        end

        function *(p::rFFTWPlan{$Tr,$FORWARD,false}, x::StridedArray{$Tr,N}) where N
            assert_applicable(p, x)
            y = Array{$Tc}(undef, p.osz)
            unsafe_execute!(p, x, y)
            return y
        end

        function *(p::rFFTWPlan{$Tc,$BACKWARD,false}, x::StridedArray{$Tc,N}) where N
            if p.flags & PRESERVE_INPUT != 0
                assert_applicable(p, x)
                y = Array{$Tr}(undef, p.osz)
                unsafe_execute!(p, x, y)
            else # need to make a copy to avoid overwriting x
                xc = copy(x)
                assert_applicable(p, xc)
                y = Array{$Tr}(undef, p.osz)
                unsafe_execute!(p, xc, y)
            end
            return y
        end
    end
end

# FFTW r2r transforms (low-level interface)

_ntupleid(v) = ntuple(identity, v)
for f in (:r2r, :r2r!)
    pf = Symbol("plan_", f)
    @eval begin
        $f(x::AbstractArray{<:fftwNumber}, kinds) = $pf(x, kinds) * x
        $f(x::AbstractArray{<:fftwNumber}, kinds, region) = $pf(x, kinds, region) * x
        $pf(x::AbstractArray, kinds; kws...) = $pf(x, kinds, _ntupleid(Val(ndims(x))); kws...)
        $f(x::AbstractArray{<:Real}, kinds, region=_ntupleid(Val(ndims(x)))) = $f(fftwfloat(x), kinds, region)
        $pf(x::AbstractArray{<:Real}, kinds, region; kws...) = $pf(fftwfloat(x), kinds, region; kws...)
        $f(x::AbstractArray{<:Complex}, kinds, region=_ntupleid(Val(ndims(x)))) = $f(fftwcomplex(x), kinds, region)
        $pf(x::AbstractArray{<:Complex}, kinds, region; kws...) = $pf(fftwcomplex(x), kinds, region; kws...)
    end
end

function plan_r2r(X::StridedArray{T,N}, kinds, region;
                  flags::Integer=ESTIMATE,
                  timelimit::Real=NO_TIMELIMIT,
                  num_threads::Union{Nothing, Integer} = nothing) where {T<:fftwNumber,N}
    if num_threads !== nothing
        plan = set_num_threads(num_threads) do
            plan_r2r(X, kinds, region; flags = flags, timelimit = timelimit)
        end
        return plan
    end
    r2rFFTWPlan{T,Any,false,N}(X, fakesimilar(flags, X, T), region, kinds,
                               flags, timelimit)
end

function plan_r2r!(X::StridedArray{T,N}, kinds, region;
                   flags::Integer=ESTIMATE,
                   timelimit::Real=NO_TIMELIMIT,
                   num_threads::Union{Nothing, Integer} = nothing) where {T<:fftwNumber,N}
    if num_threads !== nothing
        plan = set_num_threads(num_threads) do
            plan_r2r!(X, kinds, region; flags = flags, timelimit = timelimit)
        end
        return plan
    end
    r2rFFTWPlan{T,Any,true,N}(X, X, region, kinds, flags, timelimit)
end

# mapping from r2r kind to the corresponding inverse transform
const inv_kind = Dict{Int,Int}(R2HC => HC2R, HC2R => R2HC, DHT => DHT,
                               REDFT00 => REDFT00,
                               REDFT01 => REDFT10, REDFT10 => REDFT01,
                               REDFT11 => REDFT11,
                               RODFT00 => RODFT00,
                               RODFT01 => RODFT10, RODFT10 => RODFT01,
                               RODFT11 => RODFT11)

# r2r inverses are normalized to 1/N, where N is a "logical" size
# the transform with length n and kind k:
function logical_size(n::Integer, k::Integer)
    k <= DHT && return n
    k == REDFT00 && return 2(n-1)
    k == RODFT00 && return 2(n+1)
    return 2n
end

function plan_inv(p::r2rFFTWPlan{T,K,inplace,N};
                  num_threads::Union{Nothing, Integer} = nothing) where {T<:fftwNumber,K,inplace,N}
    if num_threads !== nothing
        set_num_threads(num_threads) do
            plan = plan_inv(p)
        end
        return plan
    end
    X = Array{T}(undef, p.sz)
    # broadcast getindex to preserve tuples
    iK = fix_kinds(p.region, getindex.((inv_kind,), p.kinds))
    Y = inplace ? X : fakesimilar(p.flags, X, T)
    ScaledPlan(r2rFFTWPlan{T,Any,inplace,N}(X, Y, p.region, iK,
                                            p.flags, NO_TIMELIMIT),
               normalization(real(T),
                             map(logical_size, [p.sz...][[p.region...]], iK),
                             1:length(p.region)))
end

function mul!(y::StridedArray{T}, p::r2rFFTWPlan{T}, x::StridedArray{T}) where T
    assert_applicable(p, x, y)
    unsafe_execute!(p, x, y)
    return y
end

function *(p::r2rFFTWPlan{T,K,false}, x::StridedArray{T,N}) where {T,K,N}
    assert_applicable(p, x)
    y = Array{T}(undef, p.osz)::Array{T,N}
    unsafe_execute!(p, x, y)
    return y
end

function *(p::r2rFFTWPlan{T,K,true}, x::StridedArray{T}) where {T,K}
    assert_applicable(p, x)
    unsafe_execute!(p, x, x)
    return x
end

#######################################################################

AbstractFFTs.AdjointStyle(::cFFTWPlan) = AbstractFFTs.FFTAdjointStyle()
AbstractFFTs.AdjointStyle(::rFFTWPlan{T, FORWARD}) where {T} = AbstractFFTs.RFFTAdjointStyle()
AbstractFFTs.AdjointStyle(p::rFFTWPlan{T, BACKWARD}) where {T} = AbstractFFTs.IRFFTAdjointStyle(p.osz[first(p.region)])

# This file was formerly a part of Julia. License is MIT: https://julialang.org/license
using FFTW
using FFTW: fftw_provider
using AbstractFFTs: Plan, plan_inv
using Test
using LinearAlgebra

using Aqua
@testset "Project quality" begin
    Aqua.test_all(FFTW, stale_deps=false, piracies=false)
end

@info "FFTW provider: $(fftw_provider)"

@testset "colmajorstrides" begin
    @test @inferred(FFTW.colmajorstrides((3, 5, 7))) == (1, 3, 15)
end

m4 = [16.    2     3    13;
      5    11    10     8;
      9     7     6    12;
      4    14    15     1]

true_fft_m4 = [
    34.            34.            34.            34.;
    7. - 1.0im  -5. + 3.0im  -3. + 5.0im   1. - 7.0im;
    16.           -16.           -16.            16.;
    7. + 1.0im  -5. - 3.0im  -3. - 5.0im   1. + 7.0im ]

true_fftn_m4 = [
    136.        0          0         0 ;
    0.       20          8 + 8im   0 - 12im ;
    0.       32 + 32im   0        32 - 32im ;
    0.        0 + 12im   8 - 8im  20 ]

true_fftd2_m4 = [
    34.   13 + 11im    4   13 - 11im ;
    34.   -5 -  3im   -4   -5 +  3im ;
    34.    3 +  5im   -4    3 -  5im ;
    34.  -11 - 13im    4  -11 + 13im ]

b = rand(17,14)
b[3:6,9:12] = m4
sm4 = view(b,3:6,9:12)

m3d = map(Float32,copy(reshape(1:5*3*2, 5, 3, 2)))
true_fftd3_m3d = Array{Float32}(undef, 5, 3, 2)
true_fftd3_m3d[:,:,1] = 17:2:45
true_fftd3_m3d[:,:,2] .= -15

@testset "fft" begin
    a = rand(8) + im*rand(8)
    @test norm(ifft(fft(a)) - a) < 1e-8
    @test norm(ifft(fft(a,1),1) - a) < 1e-8
    @test norm(ifft(fft(a,[1]),[1]) - a) < 1e-8
    @test norm(ifft(fft(a,(1,)),(1,)) - a) < 1e-8
    a = rand(-10:10, 8) + im*rand(-10:10, 8)
    @test norm(ifft(fft(a)) - a) < 1e-8

    # use invoke to force usage of CTPlan versions even if FFTW is present
    for A in (Array,SubArray)
        for f in (:fft,:ifft,:plan_fft,:plan_ifft)
            f_ = Symbol(f, "_")
            @eval begin
                $f_(x::$A{T,N}) where {T,N} = invoke($f, Tuple{AbstractArray{T,N}}, x)
                $f_(x::$A{T,N},r::R) where {T,N,R} = invoke($f,Tuple{AbstractArray{T,N},R},x,r)
            end
        end
    end

    for (f,fi,pf,pfi) in ((fft,ifft,plan_fft,plan_ifft),
                          (fft_,ifft_,plan_fft_,plan_ifft_))
        pm4 = pf(m4,1)

        fft_m4 = f(m4,1)
        fftd2_m4 = f(m4,2)
        ifft_fft_m4 = fi(f(m4,1),1)
        fftn_m4 = f(m4)
        ifftn_fftn_m4 = fi(f(m4))

        fft!_m4 = complex(m4); fft!(fft!_m4,1)
        fft!d2_m4 = complex(m4); fft!(fft!d2_m4,2)
        ifft!_fft_m4 = f(m4,1); ifft!(ifft!_fft_m4,1)
        fft!n_m4 = complex(m4); fft!(fft!n_m4)
        ifft!n_fftn_m4 = f(m4); ifft!(ifft!n_fftn_m4)

        pfft_m4 = pf(m4,1)*m4
        pfftd2_m4 = pf(m4,2)*m4
        pifft_fft_m4 = pfi(fft_m4,1)*fft_m4
        pfftn_m4 = pf(m4)*m4
        pifftn_fftn_m4 = pfi(fftn_m4)*fftn_m4

        pfft!_m4 = complex(m4); plan_fft!(pfft!_m4,1)*pfft!_m4
        pfft!d2_m4 = complex(m4); plan_fft!(pfft!d2_m4,2)*pfft!d2_m4
        pifft!_fft_m4 = f(m4,1); plan_ifft!(pifft!_fft_m4,1)*pifft!_fft_m4
        pfft!n_m4 = complex(m4); plan_fft!(pfft!n_m4)*pfft!n_m4
        pifft!n_fftn_m4 = f(m4); plan_ifft!(pifft!n_fftn_m4)*pifft!n_fftn_m4

        sfftn_m4 = f(sm4)
        psfftn_m4 = pf(sm4)*sm4
        sfft!n_b = map(Complex{Float64},b)
        sfft!n_m4 = view(sfft!n_b,3:6,9:12); fft!(sfft!n_m4)
        psfft!n_b = map(Complex{Float64},b)
        psfft!n_m4 = view(psfft!n_b,3:6,9:12); plan_fft!(psfft!n_m4)*psfft!n_m4

        for i = 1:length(m4)
            @test fft_m4[i] ≈ true_fft_m4[i]
            @test fftd2_m4[i] ≈ true_fftd2_m4[i]
            @test ifft_fft_m4[i] ≈ m4[i]
            @test fftn_m4[i] ≈ true_fftn_m4[i]
            @test ifftn_fftn_m4[i] ≈ m4[i]

            @test fft!_m4[i] ≈ true_fft_m4[i]
            @test fft!d2_m4[i] ≈ true_fftd2_m4[i]
            @test ifft!_fft_m4[i] ≈ m4[i]
            @test fft!n_m4[i] ≈ true_fftn_m4[i]
            @test ifft!n_fftn_m4[i] ≈ m4[i]

            @test pfft_m4[i] ≈ true_fft_m4[i]
            @test pfftd2_m4[i] ≈ true_fftd2_m4[i]
            @test pifft_fft_m4[i] ≈ m4[i]
            @test pfftn_m4[i] ≈ true_fftn_m4[i]
            @test pifftn_fftn_m4[i] ≈ m4[i]

            @test pfft!_m4[i] ≈ true_fft_m4[i]
            @test pfft!d2_m4[i] ≈ true_fftd2_m4[i]
            @test pifft!_fft_m4[i] ≈ m4[i]
            @test pfft!n_m4[i] ≈ true_fftn_m4[i]
            @test pifft!n_fftn_m4[i] ≈ m4[i]

            @test sfftn_m4[i] ≈ true_fftn_m4[i]
            @test sfft!n_m4[i] ≈ true_fftn_m4[i]
            @test psfftn_m4[i] ≈ true_fftn_m4[i]
            @test psfft!n_m4[i] ≈ true_fftn_m4[i]
        end

        ifft!(sfft!n_m4)
        plan_ifft!(psfft!n_m4)*psfft!n_m4
        @test norm(sfft!n_m4 - m4) < 1e-8
        @test norm(psfft!n_m4 - m4) < 1e-8

        # The following capabilities are FFTW only.
        # They are not available in MKL, and hence do not test them.
        if fftw_provider == "fftw"
            @testset "FFTW-specific" begin
                ifft3_fft3_m3d = fi(f(m3d))

                fftd3_m3d = f(m3d,3)
                ifftd3_fftd3_m3d = fi(fftd3_m3d,3)

                fft!d3_m3d = complex(m3d); fft!(fft!d3_m3d,3)
                ifft!d3_fftd3_m3d = copy(fft!d3_m3d); ifft!(ifft!d3_fftd3_m3d,3)

                pfftd3_m3d = pf(m3d,3)*m3d
                pifftd3_fftd3_m3d = pfi(fftd3_m3d,3)*fftd3_m3d

                pfft!d3_m3d = complex(m3d); plan_fft!(pfft!d3_m3d,3)*pfft!d3_m3d
                pifft!d3_fftd3_m3d = copy(fft!d3_m3d); plan_ifft!(pifft!d3_fftd3_m3d,3)*pifft!d3_fftd3_m3d

                @test isa(fftd3_m3d, Array{Complex{Float32},3})
                @test isa(ifftd3_fftd3_m3d, Array{Complex{Float32},3})
                @test isa(fft!d3_m3d, Array{Complex{Float32},3})
                @test isa(ifft!d3_fftd3_m3d, Array{Complex{Float32},3})
                @test isa(pfftd3_m3d, Array{Complex{Float32},3})
                @test isa(pifftd3_fftd3_m3d, Array{Complex{Float32},3})
                @test isa(pfft!d3_m3d, Array{Complex{Float32},3})
                @test isa(pifft!d3_fftd3_m3d, Array{Complex{Float32},3})

                for i = 1:length(m3d)
                    @test fftd3_m3d[i] ≈ true_fftd3_m3d[i]
                    @test ifftd3_fftd3_m3d[i] ≈ m3d[i]
                    @test ifft3_fft3_m3d[i] ≈ m3d[i]

                    @test fft!d3_m3d[i] ≈ true_fftd3_m3d[i]
                    @test ifft!d3_fftd3_m3d[i] ≈ m3d[i]

                    @test pfftd3_m3d[i] ≈ true_fftd3_m3d[i]
                    @test pifftd3_fftd3_m3d[i] ≈ m3d[i]
                    @test pfft!d3_m3d[i] ≈ true_fftd3_m3d[i]
                    @test pifft!d3_fftd3_m3d[i] ≈ m3d[i]
                end
            end
        end  # if fftw_provider == "fftw"

    end
end

@testset "rfft/rfftn" begin
    # Test regions as int/collection
    @test rfft(m4,1) == rfft(m4,1:1) == rfft(m4,(1,)) == rfft(m4, [1])

    rfft_m4 = rfft(m4,1)
    rfftd2_m4 = rfft(m4,2)
    rfftn_m4 = rfft(m4)

    prfft_m4 = plan_rfft(m4,1)*m4
    prfftd2_m4 = plan_rfft(m4,2)*m4
    prfftn_m4 = plan_rfft(m4)*m4

    srfftn_m4 = rfft(sm4)
    psrfftn_m4 = plan_rfft(sm4)*sm4

    for i = 1:3, j = 1:4
        @test rfft_m4[i,j] ≈ true_fft_m4[i,j]
        @test rfftd2_m4[j,i] ≈ true_fftd2_m4[j,i]
        @test rfftn_m4[i,j] ≈ true_fftn_m4[i,j]

        @test prfft_m4[i,j] ≈ true_fft_m4[i,j]
        @test prfftd2_m4[j,i] ≈ true_fftd2_m4[j,i]
        @test prfftn_m4[i,j] ≈ true_fftn_m4[i,j]

        @test srfftn_m4[i,j] ≈ true_fftn_m4[i,j]
        @test psrfftn_m4[i,j] ≈ true_fftn_m4[i,j]
    end

    irfft_rfft_m4 = irfft(rfft_m4,size(m4,1),1)
    irfft_rfftd2_m4 = irfft(rfftd2_m4,size(m4,2),2)
    irfftn_rfftn_m4 = irfft(rfftn_m4,size(m4,1))

    pirfft_rfft_m4 = plan_irfft(rfft_m4,size(m4,1),1)*rfft_m4
    pirfft_rfftd2_m4 = plan_irfft(rfftd2_m4,size(m4,2),2)*rfftd2_m4
    pirfftn_rfftn_m4 = plan_irfft(rfftn_m4,size(m4,1))*rfftn_m4

    for i = 1:length(m4)
        @test irfft_rfft_m4[i] ≈ m4[i]
        @test irfft_rfftd2_m4[i] ≈ m4[i]
        @test irfftn_rfftn_m4[i] ≈ m4[i]

        @test pirfft_rfft_m4[i] ≈ m4[i]
        @test pirfft_rfftd2_m4[i] ≈ m4[i]
        @test pirfftn_rfftn_m4[i] ≈ m4[i]
    end

    @testset "with preallocated array" begin
        prfft_m4_prealloc = zero(prfft_m4)
        prfftd2_m4_prealloc = zero(prfftd2_m4)
        prfftn_m4_prealloc = zero(prfftn_m4)

        pirfft_rfft_m4_prealloc = zero(pirfft_rfft_m4)
        pirfft_rfftd2_m4_prealloc = zero(pirfft_rfftd2_m4)
        pirfftn_rfftn_m4_prealloc = zero(pirfftn_rfftn_m4)

        mul!(prfft_m4_prealloc,plan_rfft(m4,1),m4)
        mul!(prfftd2_m4_prealloc,plan_rfft(m4,2),m4)
        mul!(prfftn_m4_prealloc,plan_rfft(m4),m4)

        for i = 1:3, j = 1:4
            @test prfft_m4_prealloc[i,j] ≈ true_fft_m4[i,j]
            @test prfftd2_m4_prealloc[j,i] ≈ true_fftd2_m4[j,i]
            @test prfftn_m4_prealloc[i,j] ≈ true_fftn_m4[i,j]
        end

        mul!(pirfft_rfft_m4_prealloc,plan_irfft(rfft_m4,size(m4,1),1),prfft_m4_prealloc)
        mul!(pirfft_rfftd2_m4_prealloc,plan_irfft(rfftd2_m4,size(m4,2),2),prfftd2_m4_prealloc)
        mul!(pirfftn_rfftn_m4_prealloc,plan_irfft(rfftn_m4,size(m4,1)),prfftn_m4_prealloc)

        for i = 1:length(m4)
            @test pirfft_rfft_m4_prealloc[i] ≈ m4[i]
            @test pirfft_rfftd2_m4_prealloc[i] ≈ m4[i]
            @test pirfftn_rfftn_m4_prealloc[i] ≈ m4[i]
        end
    end

    if fftw_provider == "fftw"
        @testset "FFTW-specific" begin
            rfftn_m3d = rfft(m3d)
            rfftd3_m3d = rfft(m3d,3)
            @test size(rfftd3_m3d) == size(true_fftd3_m3d)
            irfft_rfftd3_m3d = irfft(rfftd3_m3d,size(m3d,3),3)
            irfftn_rfftn_m3d = irfft(rfftn_m3d,size(m3d,1))
            for i = 1:length(m3d)
                @test rfftd3_m3d[i] ≈ true_fftd3_m3d[i]
                @test irfft_rfftd3_m3d[i] ≈ m3d[i]
                @test irfftn_rfftn_m3d[i] ≈ m3d[i]
            end

            fftn_m3d = fft(m3d)
            @test size(fftn_m3d) == (5,3,2)
            rfftn_m3d = rfft(m3d)
            @test size(rfftn_m3d) == (3,3,2)
            for i = 1:3, j = 1:3, k = 1:2
                @test rfftn_m3d[i,j,k] ≈ fftn_m3d[i,j,k]
            end
        end # !mkl
    end
end

# FFT self-test algorithm (for unscaled 1d forward FFTs):
#   Funda Ergün, "Testing multivariate linear functions: Overcoming
#   the generator bottleneck," Proc. 27th ACM Symposium on the Theory
#   of Computing, pp. 407-416 (1995).
# Check linearity, impulse-response, and time-shift properties.
function fft_test(p::Plan{T}, ntrials=4,
                  tol=1e5 * eps(real(T))) where T<:Complex
    ndims(p) == 1 || throw(ArgumentError("not a 1d FFT"))
    n = length(p)
    twopi_i = (-2 * convert(real(T), π)/n * (0:n-1)) * im
    for trial = 1:ntrials
        # linearity:
        x = rand(T, n)
        y = rand(T, n)
        α = rand(T)
        β = rand(T)
        X = p * (α*x + β*y)
        err = norm(α * (p*x) + β * (p*y) - X, Inf) / norm(X, Inf)
        err <= tol || error("linearity error $err in $p")

        # impulse-response:
        z = zeros(T, n)
        i = rand(0:n-1)
        z[i+1] = 1
        X = exp.(twopi_i*i)
        err = norm(p*z - X, Inf) / norm(X, Inf)
        err <= tol || error("impulse-response error $err in $p")

        # time-shift:
        if n > 1
            s = rand(1:n-1)
            X = (p*x).*exp.(twopi_i*s)
            err = norm(p*circshift(x,s) - X, Inf) / norm(X, Inf)
            err <= tol || error("time-shift error $err in $p")
        end
    end
end

@testset "Self-test: $(T)" for T in (Complex{Float32}, Complex{Float64})
    for n in [1:100; 121; 143; 1000; 1024; 1031; 2000; 2048]
        x = zeros(T, n)
        fft_test(plan_fft(x))
        fft_test(plan_fft_(x))
    end
end

@testset "Inversion, scaling, and pre-allocated variants: $(T)" for T in (Complex{Float32}, Complex{Float64})
    for x in (T[1:100;], copy(reshape(T[1:200;], 20,10)))
        y = similar(x)
        for planner in (plan_fft, plan_fft_, plan_ifft, plan_ifft_)
            p = planner(x)
            pi = inv(p)
            p3 = 3*p
            p3i = inv(p3)
            @test eltype(p) == eltype(pi) == eltype(p3) == eltype(p3i) == T
            @test norm(x - p3i * (p * 3x)) < eps(real(T)) * 10000
            @test norm(3x - pi * (p3 * x)) < eps(real(T)) * 10000
            mul!(y, p, x)
            @test y == p * x
            ldiv!(y, p, x)
            @test y == p \ x
        end
    end
end

let
    plan32 = plan_fft([1.0:2048.0;])
    plan64 = plan_fft([1f0:2048f0;])
    FFTW.flops(plan32)
    FFTW.flops(plan64)
end

@testset "Base Julia issue #9772, with size $(size(x))" for x in (randn(10),randn(10,12))
    z = complex(x)
    y = rfft(x)
    @inferred rfft(x)

    if ndims(x) == 2
        @inferred brfft(x,18)
    end

    @inferred brfft(y,10)
    for f in (plan_bfft!, plan_fft!, plan_ifft!,
              plan_bfft, plan_fft, plan_ifft,
              fft, bfft, fft_, ifft)
        p = @inferred f(z)
        if isa(p, Plan)
            @inferred plan_inv(p)
        end
    end
    for f in (plan_bfft, plan_fft, plan_ifft,
              plan_rfft, fft, bfft, fft_, ifft)
        p = @inferred f(x)
        if isa(p, Plan)
            @inferred plan_inv(p)
        end
    end
    # note: inference doesn't work for plan_fft_ since the
    #       algorithm steps are included in the CTPlan type
end

@testset "Base Julia issue #17896" begin
    a = rand(5)
    @test  fft(a) ==  fft(view(a,:)) ==  fft(view(a, 1:5)) ==  fft(view(a, [1:5;]))
    @test rfft(a) == rfft(view(a,:)) == rfft(view(a, 1:5)) == rfft(view(a, [1:5;]))
    a16 = convert(Vector{Float16}, a)
    @test  fft(a16) ==  fft(view(a16,:)) ==  fft(view(a16, 1:5)) ==  fft(view(a16, [1:5;]))
    @test rfft(a16) == rfft(view(a16,:)) == rfft(view(a16, 1:5)) == rfft(view(a16, [1:5;]))
end

if fftw_provider == "fftw"
    @testset "Discrete cosine transform (DCT) tests" begin
        a = rand(8,11) + im*rand(8,11)
        @test norm(idct(dct(a)) - a) < 1e-8

        X = reshape([1,2,7,2,1,5,9,-1,3,4,6,9],3,4)
        Y = rand(17,14)
        Y[3:5,9:12] = X
        sX = view(Y,3:5,9:12)

        true_Xdct = [  13.856406460551018  -3.863239728836245   2.886751345948129  -0.274551994240164; -2.828427124746190  -2.184015211898548  -4.949747468305834   3.966116180118245; 4.898979485566356  -0.194137576915510  -2.857738033247041   2.731723009609389 ]

        true_Xdct_1 = [    5.773502691896258   4.618802153517007   6.350852961085884  10.969655114602890; -4.242640687119286  -2.121320343559643   4.242640687119286  -3.535533905932738; 1.632993161855452   2.041241452319315   5.715476066494083   0.408248290463863 ]

        true_Xdct_2 = [    8.  -3.854030797826254  -3.0  3.761176226848022;
                           4.0  -2.071929829606556   4.0  -2.388955165168770; 12.  -0.765366864730179   4.0  -1.847759065022573 ]

        Xdct = dct(X)
        Xdct! = float(X); dct!(Xdct!)
        Xdct_1 = dct(X,1)
        Xdct!_1 = float(X); dct!(Xdct!_1,1)
        Xdct_2 = dct(X,2)
        Xdct!_2 = float(X); dct!(Xdct!_2,2)

        Xidct = idct(true_Xdct)
        Xidct! = copy(true_Xdct); idct!(Xidct!)
        Xidct_1 = idct(true_Xdct_1,1)
        Xidct!_1 = copy(true_Xdct_1); idct!(Xidct!_1,1)
        Xidct_2 = idct(true_Xdct_2,2)
        Xidct!_2 = copy(true_Xdct_2); idct!(Xidct!_2,2)

        pXdct = plan_dct(X)*(X)
        pXdct! = float(X); plan_dct!(pXdct!)*(pXdct!)
        pXdct_1 = plan_dct(X,1)*(X)
        pXdct!_1 = float(X); plan_dct!(pXdct!_1,1)*(pXdct!_1)
        pXdct_2 = plan_dct(X,2)*(X)
        pXdct!_2 = float(X); plan_dct!(pXdct!_2,2)*(pXdct!_2)

        pXidct = plan_idct(true_Xdct)*(true_Xdct)
        pXidct! = copy(true_Xdct); plan_idct!(pXidct!)*(pXidct!)
        pXidct_1 = plan_idct(true_Xdct_1,1)*(true_Xdct_1)
        pXidct!_1 = copy(true_Xdct_1); plan_idct!(pXidct!_1,1)*(pXidct!_1)
        pXidct_2 = plan_idct(true_Xdct_2,2)*(true_Xdct_2)
        pXidct!_2 = copy(true_Xdct_2); plan_idct!(pXidct!_2,2)*(pXidct!_2)

        sXdct = dct(sX)
        psXdct = plan_dct(sX)*(sX)
        sYdct! = copy(Y); sXdct! = view(sYdct!,3:5,9:12); dct!(sXdct!)
        psYdct! = copy(Y); psXdct! = view(psYdct!,3:5,9:12); plan_dct!(psXdct!)*(psXdct!)

        for i = 1:length(X)
            @test Xdct[i] ≈ true_Xdct[i]
            @test Xdct![i] ≈ true_Xdct[i]
            @test Xdct_1[i] ≈ true_Xdct_1[i]
            @test Xdct!_1[i] ≈ true_Xdct_1[i]
            @test Xdct_2[i] ≈ true_Xdct_2[i]
            @test Xdct!_2[i] ≈ true_Xdct_2[i]

            @test pXdct[i] ≈ true_Xdct[i]
            @test pXdct![i] ≈ true_Xdct[i]
            @test pXdct_1[i] ≈ true_Xdct_1[i]
            @test pXdct!_1[i] ≈ true_Xdct_1[i]
            @test pXdct_2[i] ≈ true_Xdct_2[i]
            @test pXdct!_2[i] ≈ true_Xdct_2[i]

            @test Xidct[i] ≈ X[i]
            @test Xidct![i] ≈ X[i]
            @test Xidct_1[i] ≈ X[i]
            @test Xidct!_1[i] ≈ X[i]
            @test Xidct_2[i] ≈ X[i]
            @test Xidct!_2[i] ≈ X[i]

            @test pXidct[i] ≈ X[i]
            @test pXidct![i] ≈ X[i]
            @test pXidct_1[i] ≈ X[i]
            @test pXidct!_1[i] ≈ X[i]
            @test pXidct_2[i] ≈ X[i]
            @test pXidct!_2[i] ≈ X[i]

            @test sXdct[i] ≈ true_Xdct[i]
            @test psXdct[i] ≈ true_Xdct[i]
            @test sXdct![i] ≈ true_Xdct[i]
            @test psXdct![i] ≈ true_Xdct[i]
        end
    end
end # fftw_provider == "fftw"

@testset "UNALIGNED flag" begin
    A = rand(Float32, 35)
    Ac = rand(Complex{Float32}, 35)
    Y = Array{Complex{Float32}}(undef, 20)
    Yc = Array{Complex{Float32}}(undef, 35)
    planr = plan_rfft(Array{Float32}(undef, 32), flags=FFTW.UNALIGNED)
    planc = plan_fft(Array{Complex{Float32}}(undef, 32), flags=FFTW.UNALIGNED)
    for ioff in 0:3
        ii = 1+ioff:32+ioff
        @test planr * view(A, ii) ≈ planr * A[ii] ≈ rfft(view(A, ii)) ≈ rfft(A[ii])
        @test planc * view(Ac, ii) ≈ planc * Ac[ii] ≈ fft(view(Ac, ii)) ≈ fft(Ac[ii])
        for ooff in 0:3
            io = 1+ooff:17+ooff
            FFTW.mul!(view(Y, io), planr, view(A, ii))
            @test Y[io] ≈ rfft(A[ii])
            FFTW.mul!(view(Y, io), planr, A[ii])
            @test Y[io] ≈ rfft(A[ii])
            io = 1+ooff:32+ooff
            FFTW.mul!(view(Yc, io), planc, view(Ac, ii))
            @test Yc[io] ≈ fft(Ac[ii])
            FFTW.mul!(view(Yc, io), planc, Ac[ii])
            @test Yc[io] ≈ fft(Ac[ii])
        end
    end

    # check whether FFTW on this architecture has nontrivial alignment requirements
    nontrivial_alignment = FFTW.fftw_provider == "fftw" && ccall((:fftwf_alignment_of, FFTW.libfftw3f), Int32, (Int,), 8) != 0
    if nontrivial_alignment
        @test_throws ArgumentError plan_rfft(Array{Float32}(undef, 32)) * view(A, 2:33)
        @test_throws ArgumentError plan_fft(Array{Complex{Float32}}(undef, 32)) * view(Ac, 2:33)
    end
end

@testset "Base Julia issue #19892" begin
    a = randn(10^5,1)
    FFTW.set_num_threads(1)
    p1 = plan_rfft(a, flags=FFTW.ESTIMATE)
    FFTW.set_num_threads(2)
    p2 = plan_rfft(a, flags=FFTW.ESTIMATE)
    @test p1*a ≈ p2*a
    # make sure threads are actually being used for p2
    # (tests #21163).
    if FFTW.has_sprint_plan
        @test !occursin("dft-thr", string(p1))
        @test occursin("dft-thr", string(p2))
    end
end

@testset "Setting and getting planner nthreads" begin
    FFTW.set_num_threads(1)
    @test FFTW.get_num_threads() == 1
    FFTW.set_num_threads(2)
    @test FFTW.get_num_threads() == 2
    plan = FFTW.set_num_threads(1) do # Should leave get_num_threads unchanged
        plan_rfft(m4, 1)
    end
    @test FFTW.get_num_threads() == 2 # Unchanged
end

@testset "type-inference in r2r plans" begin
    # Compare with definition
    function testr2r(::Type{T}) where {T}
        n = 4
        v = T[1:n;]
        plan = @inferred (() -> FFTW.plan_r2r(v, FFTW.REDFT10))()
        w = plan * v
        @test w ≈ [2sum(j->v[j+1]*cos(pi*(j+1/2)*k/n), 0:n-1) for k in 0:n-1]
        invplan = @inferred FFTW.plan_inv(plan)
        @test invplan * w ≈ v
    end
    @testset for T in (Float32, Float64)
        testr2r(T)
    end
    # complex r2r is broken on mkl
    if FFTW.get_provider() == "fftw"
        @testset for T in (ComplexF32, ComplexF64)
            testr2r(T)
        end
    end
end

@testset "DCT adjoints" begin
    # only test on FFTW because MKL is missing functionality
    if FFTW.get_provider() == "fftw"
        for x in (randn(3), randn(4), randn(3, 4), randn(3, 4, 5))
            y = randn(size(x))
            N = ndims(x)
            for dims in unique((1, 1:N, N))
                for P in (plan_dct(x, dims), plan_idct(x, dims))
                    AbstractFFTs.TestUtils.test_plan_adjoint(P, x)
                end
            end
        end
    end
end

@testset "AbstractFFTs FFT backend tests" begin
    # note this also tests adjoint functionality for FFT plans
    # only test on FFTW because MKL is missing functionality
    if FFTW.get_provider() == "fftw"
        AbstractFFTs.TestUtils.test_complex_ffts(Array)
        AbstractFFTs.TestUtils.test_real_ffts(Array; copy_input=true)
    end
end

function get_provider()
    # Note: we CANNOT do something like have the `default` value be `get(ENV, "JULIA_FFTW_PROVIDER", "fftw")` here.
    # This is because the only way the Julia knows that a default has changed is if the values on-disk change; so
    # if your "default" value can be changed from the outside, you quickly run into cache invalidation issues.
    # So the default here _must_ be a constant.
    default_provider = "fftw"

    # Load the preference
    provider = @load_preference("provider", default_provider)

    # Ensure the provider matches one of the ones we support
    if provider ∉ ("fftw", "mkl")
        @error("Invalid provider setting \"$(provider)\"; valid settings include [\"fftw\", \"mkl\"], defaulting to \"fftw\"")
        provider = default_provider
    end
    return provider
end

# Read in preferences, see if any users have requested a particular backend
const fftw_provider = get_provider()

"""
    set_provider!(provider; export_prefs::Bool = false)

Convenience wrapper for setting the FFT provider.  Valid values include `"fftw"`, `"mkl"`.
Also supports `Preferences` sentinel values `nothing` and `missing`; see the docstring for
`Preferences.set_preferences!()` for more information on what these values mean.
"""
function set_provider!(provider; export_prefs::Bool = false)
    if provider !== nothing && provider !== missing && provider ∉ ("fftw", "mkl")
        throw(ArgumentError("Invalid provider value '$(provider)'"))
    end
    set_preferences!(@__MODULE__, "provider" => provider; export_prefs, force = true)
    if provider != fftw_provider
        # Re-fetch to get default values in the event that `nothing` or `missing` was passed in.
        provider = get_provider()
        @info("FFTW provider changed; restart Julia for this change to take effect", provider)
    end
end

# If we're using fftw_jll, load it in
@static if fftw_provider == "fftw"
    import FFTW_jll
    # callback function that FFTW uses to launch `num` parallel
    # tasks (FFTW/fftw3#175):
    function spawnloop(f::Ptr{Cvoid}, fdata::Ptr{Cvoid}, elsize::Csize_t, num::Cint, callback_data::Ptr{Cvoid})
        @sync for i = 0:num-1
            Threads.@spawn ccall(f, Ptr{Cvoid}, (Ptr{Cvoid},), fdata + elsize*i)
        end
    end

    # If FFTW was built with threads, then they must be initialized before any FFTW planning routine.
    #   -- This initializes FFTW's threads support (defaulting to 1 thread).
    #      If this isn't called before the FFTW planner is created, then
    #      FFTW's threads algorithms won't be registered or used at all.
    #      (Previously, we called fftw_cleanup, but this invalidated existing
    #       plans, causing Base Julia issue #19892.)
    function fftw_init_threads()
        stat =  ccall((:fftw_init_threads,   libfftw3_no_init), Int32, ())
        statf = ccall((:fftwf_init_threads, libfftw3f_no_init), Int32, ())
        if stat == 0 || statf == 0
            error("could not initialize FFTW threads")
        end

        if nthreads() > 1
            cspawnloop = @cfunction(spawnloop, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t, Cint, Ptr{Cvoid}))
            ccall((:fftw_threads_set_callback,  libfftw3_no_init),  Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), cspawnloop, C_NULL)
            ccall((:fftwf_threads_set_callback, libfftw3f_no_init), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), cspawnloop, C_NULL)
        end
    end
end

# If we're using MKL, load it in and set library paths appropriately.
@static if fftw_provider == "mkl"
    import MKL_jll
    const _last_num_threads = Ref(Cint(1))
end

module FFTW

using LinearAlgebra, Reexport, Preferences
@reexport using AbstractFFTs
using Base.Threads

import AbstractFFTs: Plan, ScaledPlan,
                     fft, ifft, bfft, fft!, ifft!, bfft!,
                     plan_fft, plan_ifft, plan_bfft, plan_fft!, plan_ifft!, plan_bfft!,
                     rfft, irfft, brfft, plan_rfft, plan_irfft, plan_brfft,
                     fftshift, ifftshift,
                     rfft_output_size, brfft_output_size,
                     plan_inv, normalization

export dct, idct, dct!, idct!, plan_dct, plan_idct, plan_dct!, plan_idct!

include("providers.jl")

function fftw_init_check()
    # If someone is trying to set the provider via the old environment variable, warn them that they
    # should instead use `set_provider!()` instead.
    if haskey(ENV, "JULIA_FFTW_PROVIDER")
        Base.depwarn("JULIA_FFTW_PROVIDER is deprecated; use FFTW.set_provider!() instead", :JULIA_FFTW_PROVIDER)
    end

    # Hook FFTW threads up to our partr runtime
    @static if fftw_provider == "fftw"
        fftw_init_threads()
    end
end

if VERSION >= v"1.11.0"
# This can be be deleted once FFTW_jll is upgraded to the real lazy jll code, to get the real benefits of this mess
mutable struct FakeLazyLibrary
    reallibrary::Symbol
    on_load_callback
    @atomic h::Ptr{Cvoid}
end
import Libdl: LazyLibrary, dlopen
function dlopen(lib::FakeLazyLibrary)
    h = @atomic :monotonic lib.h
    h != C_NULL && return h
    @lock fftwlock begin
        h = @atomic :monotonic lib.h
        h != C_NULL && return h
        h = dlopen(getglobal(FFTW, lib.reallibrary))
        lib.on_load_callback()
        @atomic :release lib.h = h
    end
    return h
end

@static if fftw_provider == "fftw"
    import FFTW_jll: libfftw3 as libfftw3_no_init,
                     libfftw3f as libfftw3f_no_init
elseif fftw_provider == "mkl"
    import MKL_jll: libmkl_rt as libfftw3_no_init,
                    libmkl_rt as libfftw3f_no_init
end
const libfftw3 = FakeLazyLibrary(:libfftw3_no_init, fftw_init_check, C_NULL)
const libfftw3f = FakeLazyLibrary(:libfftw3f_no_init, fftw_init_check, C_NULL)

else
@static if fftw_provider == "fftw"
    import FFTW_jll: libfftw3_path as libfftw3_no_init,
                     libfftw3f_path as libfftw3f_no_init,
                     libfftw3_path as libfftw3,
                     libfftw3f_path as libfftw3f
elseif fftw_provider == "mkl"
    import MKL_jll: libmkl_rt_path as libfftw3_no_init,
                    libmkl_rt_path as libfftw3f_no_init,
                    libmkl_rt_path as libfftw3,
                    libmkl_rt_path as libfftw3f
end
function __init__()
    fftw_init_check()
end
end


# most FFTW calls other than fftw_execute should be protected by a lock to be thread-safe
const fftwlock = ReentrantLock()

# protect thread-safety of expressions or whole functions by fftwlock:
macro exclusive(ex)
    if Meta.isexpr(ex, :function) || (Meta.isexpr(ex, :(=)) && Meta.isexpr(ex.args[1], :call))
        newbody = quote
            lock(fftwlock)
            try
                $(esc(ex.args[2]))
            finally
                unlock(fftwlock)
                destroy_deferred() # deallocate plans queued to be destroyed while we held the lock
            end
        end
        Expr(:function, esc(ex.args[1]), newbody)
    else
        return quote
            lock(fftwlock)
            try
                $(esc(ex))
            finally
                unlock(fftwlock)
                destroy_deferred() # deallocate plans queued to be destroyed while we held the lock
            end
        end
    end
end

include("fft.jl")
include("dct.jl")

include("precompile.jl")
_precompile_()

end # module

function _precompile_()
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
    for n = 1:3, T in (Float32, Float64, ComplexF32, ComplexF64), D in (UnitRange{Int}, Vector{Int}, Int)
        precompile(Tuple{typeof(fft),Array{T,n},D})
        precompile(Tuple{typeof(rfft),Array{T,n},D})
        precompile(Tuple{typeof(ifft),Array{T,n},D})
        precompile(Tuple{typeof(irfft),Array{T,n},Int,D})
        precompile(Tuple{typeof(rfft_output_size),Tuple{Int, Int, Int},D})
        precompile(Tuple{typeof(rfft_output_size),Tuple{Int, Int},D})
        precompile(Tuple{typeof(rfft_output_size),Tuple{Int},D})
    end
end

using Documenter, DocumenterInterLinks, FFTW

links = InterLinks(
    "Julia" => "https://docs.julialang.org/en/v1/",
    "AbstractFFTs" => "https://juliamath.github.io/AbstractFFTs.jl/dev/",
)

makedocs(
    modules = [FFTW],
    clean = false,
    repo = Remotes.GitHub("JuliaMath", "FFTW.jl"),
    sitename = "FFTW.jl",
    pages = Any[
        "Home" => "index.md",
        "API" => "fft.md",
        "Examples" => "examples.md",
    ],
    plugins=[links],
)

deploydocs(
    repo = "github.com/JuliaMath/FFTW.jl.git",
    target = "build",
    deps = nothing,
    make = nothing,
)

# This file was formerly a part of Julia. License is MIT: https://julialang.org/license

# (This is part of the FFTW module.)

"""
    plan_dct!(A [, dims [, flags [, timelimit [, num_threads]]]])

Same as [`plan_dct`](@ref), but operates in-place on `A`.
"""
function plan_dct! end

"""
    plan_idct(A [, dims [, flags [, timelimit [, num_threads]]]])

Pre-plan an optimized inverse discrete cosine transform (DCT), similar to [`plan_fft`](@extref `AbstractFFTs.plan_fft`)
except producing a function that computes [`idct`](@ref). The first two arguments have the same meaning as for
[`idct`](@ref).
"""
function plan_idct end

"""
    plan_dct(A [, dims [, flags [, timelimit [, num_threads]]]])

Pre-plan an optimized discrete cosine transform (DCT), similar to [`plan_fft`](@extref `AbstractFFTs.plan_fft`) except
producing a function that computes [`dct`](@ref). The first two arguments have the same meaning as for [`dct`](@ref).
"""
function plan_dct end

"""
    plan_idct!(A [, dims [, flags [, timelimit [, num_threads]]]])

Same as [`plan_idct`](@ref), but operates in-place on `A`.
"""
function plan_idct! end

"""
    dct(A [, dims])

Performs a multidimensional type-II discrete cosine transform (DCT) of the array `A`, using the unitary normalization of
the DCT. The optional `dims` argument specifies an iterable subset of dimensions (e.g. an integer, range, tuple, or
array) to transform along.  Most efficient if the size of `A` along the transformed dimensions is a product of small
primes; see [`nextprod`](@extref `Base.nextprod`). See also [`plan_dct`](@ref) for even greater efficiency.
"""
function dct end

"""
    idct(A [, dims])

Computes the multidimensional inverse discrete cosine transform (DCT) of the array `A`
(technically, a type-III DCT with the unitary normalization). The optional `dims` argument
specifies an iterable subset of dimensions (e.g. an integer, range, tuple, or array) to
transform along.  Most efficient if the size of `A` along the transformed dimensions is a
product of small primes; see [`nextprod`](@extref `Base.nextprod`).  See also
[`plan_idct`](@ref) for even greater efficiency.
"""
function idct end

"""
    dct!(A [, dims])

Same as [`dct`](@ref), except that it operates in-place on `A`, which must be an
array of real or complex floating-point values.
"""
function dct! end

"""
    idct!(A [, dims])

Same as [`idct`](@ref), but operates in-place on `A`.
"""
function idct! end

# Discrete cosine transforms (type II/III) via FFTW's r2r transforms;
# we follow the Matlab convention and adopt a unitary normalization here.
# Unlike Matlab we compute the multidimensional transform by default,
# similar to the Julia fft functions.

mutable struct DCTPlan{T<:fftwNumber,K,inplace,G,R<:r2rFFTWPlan{T}} <: Plan{T}
    plan::R
    r::Vector{UnitRange{Int}} # array of indices for rescaling
    nrm::Float64 # normalization factor
    region::G # dimensions being transformed
    pinv::DCTPlan{T}
    DCTPlan{T,K,inplace}(plan::R,r,nrm,region::G) where {T<:fftwNumber,K,inplace,G,R<:r2rFFTWPlan{T}} =
        new{T,K,inplace,G,R}(plan,r,nrm,region)
end

size(p::DCTPlan) = size(p.plan)

function show(io::IO, p::DCTPlan{T,K,inplace}) where {T,K,inplace}
    print(io, inplace ? "FFTW in-place " : "FFTW ",
          K == REDFT10 ? "DCT (DCT-II)" : "IDCT (DCT-III)", " plan for ")
    showfftdims(io, p.plan.sz, p.plan.istride, eltype(p))
end

for (pf, pfr, K, inplace) in ((:plan_dct, :plan_r2r, REDFT10, false),
                              (:plan_dct!, :plan_r2r!, REDFT10, true),
                              (:plan_idct, :plan_r2r, REDFT01, false),
                              (:plan_idct!, :plan_r2r!, REDFT01, true))
    @eval function $pf(X::StridedArray{T}, region; kws...) where T<:fftwNumber
        r = [1:n for n in size(X)]
        nrm = sqrt(0.5^length(region) * normalization(X,region))
        DCTPlan{T,$K,$inplace}($pfr(X, $K, region; kws...), r, nrm,
                               ntuple(i -> Int(region[i]), length(region)))
    end
end

function plan_inv(p::DCTPlan{T,K,inplace}) where {T,K,inplace}
    X = Array{T}(undef, p.plan.sz)
    iK = inv_kind[K]
    DCTPlan{T,iK,inplace}(inplace ?
                          plan_r2r!(X, iK, p.region, flags=p.plan.flags) :
                          plan_r2r(X, iK, p.region, flags=p.plan.flags),
                          p.r, p.nrm, p.region)
end

for f in (:dct, :dct!, :idct, :idct!)
    pf = Symbol("plan_", f)
    @eval begin
        $f(x::AbstractArray{<:fftwNumber}) = $pf(x) * x
        $f(x::AbstractArray{<:fftwNumber}, region) = $pf(x, region) * x
        $pf(x::AbstractArray; kws...) = $pf(x, 1:ndims(x); kws...)
        $f(x::AbstractArray{<:Real}, region=1:ndims(x)) = $f(fftwfloat(x), region)
        $pf(x::AbstractArray{<:Real}, region; kws...) = $pf(fftwfloat(x), region; kws...)
        $pf(x::AbstractArray{<:Complex}, region; kws...) = $pf(fftwcomplex(x), region; kws...)
    end
end

const sqrthalf = sqrt(0.5)
const sqrt2 = sqrt(2.0)
const onerange = 1:1

function mul!(y::StridedArray{T}, p::DCTPlan{T,REDFT10}, x::StridedArray{T}) where T
    assert_applicable(p.plan, x, y)
    unsafe_execute!(p.plan, x, y)
    rmul!(y, p.nrm)
    r = p.r
    for d in p.region
        oldr = r[d]
        r[d] = onerange
        y[r...] *= sqrthalf
        r[d] = oldr
    end
    return y
end

# note: idct changes input data
function mul!(y::StridedArray{T}, p::DCTPlan{T,REDFT01}, x::StridedArray{T}) where T
    assert_applicable(p.plan, x, y)
    rmul!(x, p.nrm)
    r = p.r
    for d in p.region
        oldr = r[d]
        r[d] = onerange
        x[r...] *= sqrt2
        r[d] = oldr
    end
    unsafe_execute!(p.plan, x, y)
    return y
end

*(p::DCTPlan{T,REDFT10,false}, x::StridedArray{T}) where {T} =
    mul!(Array{T}(undef, p.plan.osz), p, x)

*(p::DCTPlan{T,REDFT01,false}, x::StridedArray{T}) where {T} =
    mul!(Array{T}(undef, p.plan.osz), p, copy(x)) # need copy to preserve input

*(p::DCTPlan{T,K,true}, x::StridedArray{T}) where {T,K} = mul!(x, p, x)

AbstractFFTs.AdjointStyle(::DCTPlan) = AbstractFFTs.UnitaryAdjointStyle()

# FFTW.jl

This package provides bindings to the [FFTW](http://www.fftw.org/) library for
fast Fourier transforms.

## Installation

The package is available for Julia versions 1.0 and later.
To install it, run

```julia
using Pkg
Pkg.add("FFTW")
```

from the Julia REPL.

Users with a build of Julia based on Intel's Math Kernel Library (MKL) can use MKL for FFTs by setting a preference in
their top-level project by either using the [`FFTW.set_provider!()`](@ref) method, or by directly setting the preference
using [`Preferences.jl`](https://github.com/JuliaPackaging/Preferences.jl).  Note that this choice will be recorded for
the current project, and other projects that wish to use MKL for FFTs should also set that same preference. Note further
that MKL provides only a subset of the functionality provided by FFTW. See Intel's
[documentation](https://software.intel.com/en-us/mkl-developer-reference-c-using-fftw3-wrappers) for more information
about potential differences or gaps in functionality.

# Fourier Transforms

This package extends the functionality provided by
[AbstractFFTs](https://github.com/JuliaMath/AbstractFFTs.jl).
To learn more about those functions, consult that package's
[documentation](https://juliamath.github.io/AbstractFFTs.jl/stable/api/).

The following functions are unique to this package.

```@docs
FFTW.r2r
FFTW.r2r!
FFTW.plan_r2r
FFTW.plan_r2r!
FFTW.dct
FFTW.idct
FFTW.dct!
FFTW.idct!
FFTW.plan_dct
FFTW.plan_idct
FFTW.plan_dct!
FFTW.plan_idct!
FFTW.set_provider!
```

# Examples

Here you can find some basic examples of how to use this package.


## Spectrum of a 1D Signal

This example shows how to obtain and plot the spectrum of a simple, real-valued signal with a second-order harmonic using FFTW and [Plots](https://github.com/JuliaPlots/Plots.jl).

```julia
using Plots
using FFTW

# Number of points
N = 2^12 - 1
# Sample spacing
Ts = 1 / (1.1 * N)
# Sample rate
fs = 1 / Ts
# Start time
t0 = 0
tmax = t0 + N * Ts

# time coordinate
t = t0:Ts:tmax

# The underlying signal here is the sum of a sine wave at 60 cycles per second
# and its second harmonic (120 cycles per second) at half amplitude. We have
# discrete observations (samples) of this signal at each time `t`, with `fs`
# samples per second.

signal = sin.(2π * 60 * t) + .5 * sin.(2π * 120 * t)

# The `fft` function calculates the (discrete) Fourier transform of its input.
# The first half of the returned array contains the positive frequencies, while
# the second half contains the negative ones. For visualization purposes, we
# rearrange the array to have the zero-frequency at the center.

F = fftshift(fft(signal))
freqs =  fftshift(fftfreq(length(t), fs))

# Plot
time_domain = plot(t, signal, title="Signal", xlims=(0, 4 / 60), xlabel="time (s)", label="")
freq_domain = plot(freqs, abs.(F), title="Spectrum", xlims=(0, 200), xlabel="frequency (Hz)", label="")
plot(time_domain, freq_domain, layout = 2)
savefig("Wave.pdf")
```

![](img/1D60Hz.png)
